// Copyright (c) 2011-2013, HL7, Inc & Mitre
// All rights reserved.
// 
// Redistribution and use in source and binary forms, with or without modification, 
// are permitted provided that the following conditions are met:
// 
//     * Redistributions of source code must retain the above copyright notice, this 
//       list of conditions and the following disclaimer.
//     * Redistributions in binary form must reproduce the above copyright notice, 
//       this list of conditions and the following disclaimer in the documentation 
//       and/or other materials provided with the distribution.
//     * Neither the name of HL7 nor the names of its contributors may be used to 
//       endorse or promote products derived from this software without specific 
//       prior written permission.
// 
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND 
// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
// IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
// INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT 
// NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR 
// PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
// WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
// ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
// POSSIBILITY OF SUCH DAMAGE.

var mongoose = require('mongoose');

var ObservationSchema = new mongoose.Schema({
    name: {
        coding: [{
            system: String,
            code: String,
            display: String
        }]
    },
    valueQuantity: {
        value: String,
        units: String,
        system: String,
        code: String
    },
    valueCodeableConcept: {
        coding: [{
            system: String,
            code: String,
            display: String
        }]
    },
    valueAttachment: {
    },
    valueRatio: {
    },
    valuePeriod: {
    },
    valueSampledData: {
    },
    valueString: String,
    interpretation: {
        coding: [{
            system: String,
            code: String,
            display: String
        }]
    },
    comments: String,
    appliesDateTime: Date,
    appliesPeriod: {
    },
    issued: Date,
    status: String,
    reliability: String,
    bodySite: {
        coding: [{
            system: String,
            code: String,
            display: String
        }]
    },
    method: {
        coding: [{
            system: String,
            code: String,
            display: String
        }]
    },
    identifier: {
        use: String,
        label: String,
        system: String,
        value: String
    },
    subject: {
        reference: String,
        display: String
    },
    specimen: {
        reference: String,
        display: String
    },
    performer: [{
        reference: String,
        display: String
    }],
    referenceRange: [{
        low: {
            value: String,
            units: String,
            system: String,
            code: String
        },
        high: {
            value: String,
            units: String,
            system: String,
            code: String
        },
        meaning: {
            coding: [{
                system: String,
                code: String,
                display: String
            }]
        },
        age: {
        }
    }],
    related: [{
        fhirType: String,
        target: {
            reference: String,
            display: String
        }
    }]
});

mongoose.model('Observation', ObservationSchema);
